import { type ITemplate, type IProperty, type INode, type INodeElement, ITemplateType, IPropertyType } from "../template/ir.js";
import { TemplateScanner } from "../template/parser.js";
export declare const parseTemplate: (s: string[] | TemplateStringsArray, type: ITemplateType, tryHoistExpr: (i: number, staticPart: boolean) => boolean) => ITemplate;
export declare class TemplateParser extends TemplateScanner {
    readonly tryHoistExpr: (i: number, staticPart: boolean) => boolean;
    constructor(statics: string[] | TemplateStringsArray, tryHoistExpr: (i: number, staticPart: boolean) => boolean);
    parse(): INode[];
    parseChildrenList(): INode[];
    parseElement(): INodeElement;
    parseAttributes(): IProperty[];
    dynamicProp(properties: IProperty[], type: IPropertyType, key: string): void;
    parseAttributeString(): string;
    parseText(state: number): string;
    whitespace(): number;
}
//# sourceMappingURL=parser.d.ts.map