import { type INode, type INodeElement, type IProperty } from "./ir.js";
export declare const normalizeTemplate: (nodes: INode[]) => INode[];
export declare const enum SNodeFlags {
    /** Has expressions in the subtree. */
    HasExpressions = 1,
    /** Has expressions in the subtrees of next siblings. */
    HasNextExpressions = 2,
    /** Has next DOM node. */
    HasNextDOMNode = 4
}
export interface SNode<T extends INode = INode> {
    readonly node: T;
    stateIndex: number;
    children: SNode[] | null;
    propsExprs: number;
    childrenExprs: number;
    flags: number;
}
export declare const createSNode: (node: INodeElement, flags: number) => SNode<INodeElement>;
export declare const isStaticProperty: (prop: IProperty) => boolean;
export declare const isVoidElement: (tag: string) => boolean;
//# sourceMappingURL=shared.d.ts.map